import "../chunk-G2ADBYYC.js";
import {
  initPositions,
  updatePositions,
  calculateTotalSize,
  handleScroll,
  scrollToItem,
  scrollToPosition
} from "./index";
import { initService } from "../user";
const api = [
  "state",
  "handleScroll",
  "virtualScroll",
  "items",
  "initPositions",
  "updatePositions",
  "calculateTotalSize",
  "scrollToItem"
];
const renderless = (props, { reactive, nextTick, watch, onMounted, ref, computed }, { service }) => {
  service = initService({ props, service });
  const api2 = {};
  const state = reactive({
    data: [...props.data],
    visibleData: [],
    translate: 0,
    totalSize: 0,
    positions: [],
    // 不定高度的列表缓存
    lastUpdateTime: Date.now()
  });
  const virtualScroll = ref(null);
  const items = ref([]);
  Object.assign(api2, {
    state,
    virtualScroll,
    items,
    handleScroll: handleScroll({ state, props, virtualScroll, nextTick, items }),
    updatePositions: updatePositions({ state, items, props }),
    initPositions: initPositions({ props, state }),
    calculateTotalSize: calculateTotalSize({ props, state }),
    scrollToItem: scrollToItem({ api: api2, props, state }),
    scrollToPosition: scrollToPosition({ api: api2, virtualScroll, state, props })
  });
  api2.initPositions();
  state.temporary = {};
  if (props.prerender) {
    state.temporary.prerender = true;
    api2.handleScroll();
  }
  const handle = () => {
    if (!virtualScroll.value)
      return;
    nextTick(() => {
      api2.initPositions();
      state.temporary.prerender = false;
      state.totalSize = api2.calculateTotalSize();
      api2.handleScroll();
    });
  };
  onMounted(handle);
  watch(
    () => props.data,
    (newData) => {
      state.data = newData;
      state.totalSize = api2.calculateTotalSize();
      nextTick(api2.handleScroll);
    },
    { deep: true }
  );
  watch(
    () => props.data,
    (newData) => {
      state.data = newData;
      nextTick(api2.handleScroll);
    },
    { deep: true }
  );
  return api2;
};
export {
  api,
  renderless
};
